;
;
; /////////////////////// PureLZMA Packer test ///////////////////////
;
;
XIncludeFile "PureLZMA_Packer_DLL_Include.pb"
;
If PureLZMA_DLL_Archive_Create(#PB_Compiler_Home + "\Examples\PureLZMA\TestArchive.arc")
  PureLZMA_DLL_Archive_Compress(#PB_Compiler_Home + "Examples\Sources\Screen3DRequester.pb", 0)
  PureLZMA_DLL_Archive_Compress(#PB_Compiler_Home + "Examples\Sources\MDI ImageViewer.pb", 0)
  PureLZMA_DLL_Archive_Compress(#PB_Compiler_Home + "Examples\Sources\Data\Background.bmp", 0)
  PureLZMA_DLL_Archive_Close()
EndIf
;
If PureLZMA_DLL_Archive_Read(#PB_Compiler_Home + "\Examples\PureLZMA\TestArchive.arc")
  ArchiveInfo.LZMA_ArchiveInfo
  If PureLZMA_DLL_Archive_FindFirst()
    ;
    PureLZMA_DLL_Archive_GetArchiveInfo(@ArchiveInfo)
    Debug "----------------"
    Debug "CRCUnpacked    = $" + RSet(Hex(ArchiveInfo\CRCUnpacked, #PB_Long), 8, "0")
    Debug "CRCPacked      = $" + RSet(Hex(ArchiveInfo\CRCPacked, #PB_Long), 8, "0")
    Debug "CRCPacked CALC = $" + RSet(Hex(PureLZMA_DLL_Archive_GetCRC(), #PB_Long), 8, "0")
    Debug "LengthUnpacked = " + Str(ArchiveInfo\LengthUnpacked)
    Debug "LengthPacked   = " + Str(ArchiveInfo\LengthPacked) + " (" + StrF(ArchiveInfo\LengthPacked / ArchiveInfo\LengthUnpacked * 100, 2) + "% of original)"
    Debug "LZMAFlags      = " + Str(ArchiveInfo\LZMAFlags)
    Debug "FileAttributes = $" + Hex(ArchiveInfo\FileAttributes)
    Debug "Filename       = '" + ArchiveInfo\FileName + "'"
    ;
    PureLZMA_DLL_Archive_Extract(#PB_Compiler_Home + "\Examples\PureLZMA\" + ArchiveInfo\FileName)
    ;
    While PureLZMA_DLL_Archive_FindNext()
      ;
      PureLZMA_DLL_Archive_GetArchiveInfo(@ArchiveInfo)
      Debug "----------------"
      Debug "CRCUnpacked    = $" + RSet(Hex(ArchiveInfo\CRCUnpacked, #PB_Long), 8, "0")
      Debug "CRCPacked      = $" + RSet(Hex(ArchiveInfo\CRCPacked, #PB_Long), 8, "0")
      Debug "CRCPacked CALC = $" + RSet(Hex(PureLZMA_DLL_Archive_GetCRC(), #PB_Long), 8, "0")
      Debug "LengthUnpacked = " + Str(ArchiveInfo\LengthUnpacked)
      Debug "LengthPacked   = " + Str(ArchiveInfo\LengthPacked) + " (" + StrF(ArchiveInfo\LengthPacked / ArchiveInfo\LengthUnpacked * 100, 2) + "% of original)"
      Debug "LZMAFlags      = " + Str(ArchiveInfo\LZMAFlags)
      Debug "FileAttributes = $" + Hex(ArchiveInfo\FileAttributes)
      Debug "Filename       = '" + ArchiveInfo\FileName + "'"
      ;
      PureLZMA_DLL_Archive_Extract(#PB_Compiler_Home + "\Examples\PureLZMA\" + ArchiveInfo\FileName)
      ;
    Wend
  EndIf
  ;
  PureLZMA_DLL_Archive_Close()
EndIf